<?php
	/*
	* 2018 - VEGA Informatique
	*
	* NOTICE OF LICENSE
	*
	* This source file is subject to the Open Software License (OSL 3.0)
	* that is bundled with this package in the file LICENSE.txt.
	* It is also available through the world-wide-web at this URL:
	* http://opensource.org/licenses/osl-3.0.php
	*
	* DISCLAIMER
	*
	* Do not edit or add to this file if you wish to upgrade PolarisLink to newer
	* versions in the future. 
	*
	*  @author VEGA Informatique <contact@vega-info.fr>
	*  @copyright  2018 VEGA Informatique
	*  @license    http://opensource.org/licenses/osl-3.0.php  Open Software License (OSL 3.0)
	*/

	if (!defined('_PS_VERSION_'))
		exit;	
		
	function upgrade_module_3_13($module)
	{
		/*
			Création de la base de données
		*/
		$db = Db::getInstance();
	
		try
		{
			$tab = new Tab();
			$tab->active = 1;
			$tab->class_name = "AdminPolarisLinkEditCategoryMappage";
			$tab->name = array();
			foreach (Language::getLanguages(true) as $lang)
				$tab->name[$lang['id_lang']] = "Editeur de mappage de catégories PolarisLink";			
			$tab->id_parent = -1;
			$tab->module = $module->name;
			$tab->add();

			// Création des options
			if (!$db->execute("CREATE TABLE `"._DB_PREFIX_."polarislink_categories_map` (
							id_link INT(10) UNSIGNED NOT NULL,
							id_category INT(10) UNSIGNED NOT NULL,
							id_category_l INT(10) UNSIGNED NOT NULL,
							is_default INT(1) NOT NULL DEFAULT 0
							) ENGINE="._MYSQL_ENGINE_." DEFAULT CHARSET=utf8;")) 
				throw new Exception("impossible de créer la table polarislink_categories_map");
			
			if (!$db->execute("ALTER TABLE `"._DB_PREFIX_."polarislink_categories_map` ADD CONSTRAINT `FK_polarislink_categories_map_sites` FOREIGN KEY (`id_link`) REFERENCES `"._DB_PREFIX_."polarislink_sites` (`id_link`) ON UPDATE CASCADE ON DELETE CASCADE;")) 
				throw new Exception(sprintf("impossible de lier la table %s à %s", "polarislink_categories_map", "polarislink_sites"));					
			if (!$db->execute("ALTER TABLE `"._DB_PREFIX_."polarislink_categories_map` ADD CONSTRAINT `FK_polarislink_categories_map_catid_s` FOREIGN KEY (`id_category`) REFERENCES `"._DB_PREFIX_."category` (`id_category`) ON UPDATE CASCADE ON DELETE CASCADE;")) 
				throw new Exception(sprintf("impossible de lier la table %s à %s", "polarislink_categories_map", "category"));
			if (!$db->execute("ALTER TABLE `"._DB_PREFIX_."polarislink_categories_map` ADD CONSTRAINT `FK_polarislink_categories_map_catid_l` FOREIGN KEY (`id_category_l`) REFERENCES `"._DB_PREFIX_."category` (`id_category`) ON UPDATE CASCADE ON DELETE CASCADE;")) 
				throw new Exception(sprintf("impossible de lier la table %s à %s", "polarislink_categories_map", "category"));

			if (!$db->execute("ALTER TABLE `"._DB_PREFIX_."polarislink_categories_map` ADD CONSTRAINT `PK_polarislink_categories_map` PRIMARY KEY (`id_link`, `id_category`, `id_category_l`);")) 
				throw new Exception(sprintf("impossible de créer la clé primaire de la table %s", "polarislink_categories_map"));
		}
		catch (Exception $ex)
		{
			$module->install_error(Tools::displayError($ex));			
			return false;
		}
				
		return true;
	 }
 